package com.example.animoi;

import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.DefaultItemAnimator;
import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
import androidx.recyclerview.widget.StaggeredGridLayoutManager;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.transition.Explode;
import android.transition.Slide;
import android.transition.Transition;
import android.view.View;
import android.view.animation.AnimationUtils;
import android.view.animation.DecelerateInterpolator;
import android.view.animation.LayoutAnimationController;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;

import java.util.ArrayList;

public class Apren extends AppCompatActivity {

    ArrayList<ItemData> itemsData;
    ImageView botonBack;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_apren);

        //Associació de variables a elements xml
        botonBack = findViewById(R.id.bBackToolbar);

        //1. Variable que referencia a RecyclerView
        final GridRecyclerView recyclerView = findViewById(R.id.rViewApren);

        //2. Definir el vector amb les dades a mostrar
        itemsData = new ArrayList();
        itemsData.add( new ItemData(getString(R.string.lection_1), getString(R.string.atomos), getString(R.string.atomos_min), getString(R.string.pregunta_1), R.drawable.atomos, 1));
        itemsData.add(new ItemData(getString(R.string.lection_2), getString(R.string.electricidad), getString(R.string.electricidad_min), getString(R.string.pregunta_2), R.drawable.electricidad, 2));
        itemsData.add( new ItemData(getString(R.string.lection_3), getString(R.string.imanes), getString(R.string.imanes_min), getString(R.string.pregunta_3), R.drawable.imanes, 3));
        itemsData.add(new ItemData(getString(R.string.lection_4), getString(R.string.motores), getString(R.string.motores_min), getString(R.string.pregunta_4), R.drawable.motor, 4));
        itemsData.add( new ItemData(getString(R.string.lection_5), getString(R.string.helices), getString(R.string.helices_min), getString(R.string.pregunta_5), R.drawable.helices, 5));
        itemsData.add(new ItemData(getString(R.string.lection_6),  getString(R.string.ultrasonido), getString(R.string.ultrasonido_min), getString(R.string.pregunta_1), R.drawable.sensor_ultrasonico, 6));

        //3. Definir el LayoutManager
       StaggeredGridLayoutManager staggeredGridLayoutManager = new StaggeredGridLayoutManager(
                2, GridLayoutManager.HORIZONTAL);
       GridLayoutManager gridLayoutManager = new GridLayoutManager(this, 3);

        //4. Colocar el LayotManager dins del RecyclerView
        recyclerView.setLayoutManager(staggeredGridLayoutManager);

        //5. Adapter
        MyAdapter mAdapter = new MyAdapter(itemsData, this);

        //6. Insertar el adapter en el contenidor RecyclerView
        recyclerView.setAdapter(mAdapter);

        //7. Animació per a passar els components a visualitzar
        final LayoutAnimationController layoutAnimationController = AnimationUtils.loadLayoutAnimation(this, R.anim.recyclerview_grid_animation);
        recyclerView.setLayoutAnimation(layoutAnimationController);


        //Animació del recyclerView associada al botó de tornar cap arrere de la toolbar
       /* botonBack.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                recyclerView.setLayoutAnimation(layoutAnimationController);
                recyclerView.getAdapter().notifyDataSetChanged();
                recyclerView.scheduleLayoutAnimation();
            }
        });*/

    }

    //Mètode per tornar al menú principal
    public void menu (View v){
        Intent menu = new Intent(Apren.this, MainActivity.class);
        startActivity(menu);
    }

    //Mètode per tornar a la pantalla anterior
    public void volver (View v){
        onBackPressed();
    }

}
