package com.example.animoi;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

public class InstructPiezas extends AppCompatActivity {

    private ImageView pieza1, pieza2, pieza3, pieza4, pieza5, pieza6;
    private TextView txPieza1, txPieza2, txPieza3, txPieza4, txPieza5, txPieza6;
    private int id, instruct, defaultValue = 0;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_instruct_piezas);

        //Assocaió de variables a elements xml
        pieza1 = findViewById(R.id.pieza1);
        pieza2 = findViewById(R.id.pieza2);
        pieza3 = findViewById(R.id.pieza3);
        pieza4 = findViewById(R.id.pieza4);
        pieza5 = findViewById(R.id.pieza5);
        pieza6 = findViewById(R.id.pieza6);
        txPieza1 = findViewById(R.id.txPieza1);
        txPieza2 = findViewById(R.id.txPieza2);
        txPieza3 = findViewById(R.id.txPieza3);
        txPieza4 = findViewById(R.id.txPieza4);
        txPieza5 = findViewById(R.id.txPieza5);
        txPieza6 = findViewById(R.id.txPieza6);

        //Intent que recupera el id i el número de la instrucció enviats en la pantalla IntroProyectos.java
        Intent i = getIntent();
        id = i.getIntExtra("id", defaultValue);
        instruct = i.getIntExtra("instruct", defaultValue);

        switch (id){
            case 0:
                if(instruct==1) {
                    pieza6.setAlpha(0f);
                    txPieza6.setAlpha(0f);
                }

                if(instruct==2){
                    pieza1.setImageResource(R.drawable.helice);
                    txPieza1.setText("2 x Hélice CW y 2 x CCW");
                    pieza2.setImageResource(R.drawable.modulo_motor_cw);
                    txPieza2.setText("2 x Motor CW ");
                    pieza3.setImageResource(R.drawable.modulo_motor_ccw);
                    txPieza3.setText("2 x Motor CCW");
                    pieza4.setImageResource(R.drawable.tapa_superior);
                    txPieza4.setText("4 x Protector Superior");
                    pieza5.setImageResource(R.drawable.tapa_inferior);
                    txPieza5.setText("4 x Protector Inferior");
                    pieza6.setAlpha(1f);
                    pieza6.setImageResource(R.drawable.topes);
                    txPieza6.setText("4 x Topes Amortiguadores");
                }

                if(instruct==3){
                    pieza1.setImageResource(R.drawable.modulo_principal2);
                    txPieza1.setText("Módulo principal");
                    pieza2.setImageResource(R.drawable.modulo_motor4);
                    txPieza2.setText("2 x Módulos de motor CW");
                    pieza3.setImageResource(R.drawable.modulo_motor5);
                    txPieza3.setText("2 x Módulos de motor CCW");
                    pieza4.setAlpha(0f);
                    txPieza4.setAlpha(0f);
                    pieza5.setAlpha(0f);
                    txPieza5.setAlpha(0f);
                    pieza6.setAlpha(0f);
                    txPieza6.setAlpha(0f);
                }

                if(instruct==4){
                    pieza1.setImageResource(R.drawable.helice);
                    txPieza2.setText("2 x Hélice CW y 2 x CCW");
                    pieza2.setImageResource(R.drawable.modulo_motor_cw);
                    txPieza2.setText("2 x Módulos de motor CW");
                    pieza3.setImageResource(R.drawable.modulo_motor_ccw);
                    txPieza3.setText("2 x Módulos de motor CCW");
                    pieza4.setAlpha(0f);
                    txPieza4.setAlpha(0f);
                    pieza5.setAlpha(0f);
                    txPieza5.setAlpha(0f);
                    pieza6.setAlpha(0f);
                    txPieza6.setAlpha(0f);
                }
            break;
        }
    }

    //Mètode per canviar de pantalla. Es passen el id i el número de la instrucció
    public void instrucciones(View v){
        Intent intentIntroMontaje = new Intent(InstructPiezas.this, InstructProyectos.class);
        intentIntroMontaje.putExtra("id", id);
        intentIntroMontaje.putExtra("instruct", instruct);
        startActivity(intentIntroMontaje);
        overridePendingTransition(R.anim.slide_in_right, R.anim.slide_out_left);
    }

    //Mètode per tornar al menú principal
    public void menu (View v){
        Intent menu = new Intent(InstructPiezas.this, MainActivity.class);
        startActivity(menu);
    }

    //Mètode que permet tornar a la pàgina anterior
    public void volver (View v){
        onBackPressed();
    }

    //Mètode que s'executa quan acaba l'activity i es passa a una altra
    @Override
    public void finish() {
        super.finish();
        overridePendingTransition(R.anim.slide_in_left, R.anim.slide_out_right);
    }
}
