package com.example.animoi;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.media.MediaPlayer;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.MediaController;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.VideoView;

import com.airbnb.lottie.LottieAnimationView;

public class InstructProyectos extends AppCompatActivity {

    private String videoPath;
    private Uri uri;
    private MediaController vidControl;
    private VideoView video;
    private TextView textInstruct, bPassInstruct;
    private int id, instruct, cont=0, defaultValue = 0, pantalla= 1;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_instruct_proyectos);

        //Assignació de variables a elements xml
        textInstruct = findViewById(R.id.txInstruccion);
        video = findViewById(R.id.video);

        //Ubicació del vídeo
        videoPath = "android.resource://" + getPackageName() + "/" +R.raw.animoi;
        uri = Uri.parse(videoPath);
        video.setVideoURI(uri);
        video.requestFocus();

        //Controls per al vídeo
        /*vidControl = new MediaController(this);
        vidControl.setAnchorView(this.video);
        video.setMediaController(vidControl);*/

        video.start();

        //Mètode que permet que el vídeo es reprodueixca en loop
        video.setOnPreparedListener(new MediaPlayer.OnPreparedListener() {
            @Override
            public void onPrepared(MediaPlayer mp) {
                mp.setLooping(true);
            }
        });

        //Intent que recupera el id i el número de la instrucció enviats en la pantalla InstructPiezas.java
        Intent i = getIntent();
        id = i.getIntExtra("id", defaultValue);
        instruct = i.getIntExtra("instruct", defaultValue);

        pasarInstrucciones();
    }


    //Mètode per passar a la instrucció següent
    public void masInstruccion(View view){
        cont++;
        pasarInstrucciones();
    }

    //Mètode per passar a la instrucció anterior
    public void menosInstruccion(View view){
        cont--;
        pasarInstrucciones();
    }

    public void pasarInstrucciones(){
        //Segons el id i el valor de instruct, les animacions explicatòres seran unes o unes altres
        if((id==0)&(instruct==2)){
            videoPath = "android.resource://" + getPackageName() + "/" +R.raw.instruct1;
            textInstruct.setText(getString(R.string.montaje2_1));

            switch (cont){
                case 0:
                    videoPath = "android.resource://" + getPackageName() + "/" +R.raw.instruct1;
                    textInstruct.setText(getString(R.string.montaje2_1));
                    break;
                case 1:
                    videoPath = "android.resource://" + getPackageName() + "/" +R.raw.instruct2;
                    textInstruct.setText(getString(R.string.montaje2_2));
                    break;

                case 2:
                    videoPath = "android.resource://" + getPackageName() + "/" +R.raw.instruct3;
                    textInstruct.setText(getString(R.string.montaje2_3));
                    break;

                case 3:
                    videoPath = "android.resource://" + getPackageName() + "/" +R.raw.instruct4;
                    textInstruct.setText(getString(R.string.montaje2_4));
                    break;

                case 4:
                    videoPath = "android.resource://" + getPackageName() + "/" +R.raw.instruct5;
                    textInstruct.setText(getString(R.string.montaje2_5));
                    break;

                case 5:
                    //Intent que permet passar a la pantalla "Volar" per tal que l'usuari pose en pràctica el projecte
                    //El id es continua enviant ja que és necessàri per a saber quin projecte s'ha completat.
                    //També s'envia un valor de la variable "pantalla", que determina si l'usuari procedeix de Vola, Monta o Aprèn
                    Intent iVolarProyectos = new Intent(InstructProyectos.this, Controles.class);
                    iVolarProyectos.putExtra("pantalla", pantalla);
                    iVolarProyectos.putExtra("id", id);
                    startActivity(iVolarProyectos);
                    break;

            }
            uri = Uri.parse(videoPath);
            video.setVideoURI(uri);
            video.requestFocus();
            video.start();
        }
        else if((id==0)&(instruct==1)&(cont==1)){
            Intent iVolarProyectos = new Intent(InstructProyectos.this, Controles.class);
            iVolarProyectos.putExtra("id", id);
            iVolarProyectos.putExtra("instruct", instruct);
            startActivity(iVolarProyectos);
        }
        else if((id==0)&(instruct==3)&(cont==1)){
            Intent iVolarProyectos = new Intent(InstructProyectos.this, Controles.class);
            iVolarProyectos.putExtra("id", id);
            iVolarProyectos.putExtra("instruct", instruct);
            startActivity(iVolarProyectos);
        }

    }

    //Mètode per tornar al menú principal
    public void menu (View v){
        Intent menu = new Intent(InstructProyectos.this, MainActivity.class);
        startActivity(menu);
    }

    //Mètode que permet tornar a la pàgina anterior
    public void volver (View v){
        onBackPressed();
    }

    //Mètode que s'executa quan acaba l'activity i es passa a una altra
    @Override
    public void finish() {
        super.finish();
        overridePendingTransition(R.anim.slide_in_left, R.anim.slide_out_right);
    }
}
