package com.example.animoi;

import androidx.appcompat.app.AppCompatActivity;
import androidx.viewpager.widget.ViewPager;

import android.content.Intent;
import android.os.Bundle;
import android.text.Html;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.List;

public class LeccionAprende extends AppCompatActivity {

    private ViewPager viewPager;
    private SliderAdapterApren adapter;
    private List<ItemExplicacion> itemExplicacions;

    private LinearLayout puntosLayout, bVolar, bAcabar, bAcabar2;
    private TextView[] puntos;
    private TextView indicador;

    int id, pantalla= 2, currentPage;
    int defaultValue = 0, numPuntos;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_leccion_aprende);

        //Assignació de variables a elements xml
        puntosLayout = findViewById(R.id.lyPuntosExp);

        indicador = findViewById(R.id.indicadorLeccion);

        //Assignació de variables per als botons. A l'inici estan deshabilitats
        bAcabar = findViewById(R.id.bAcabar);
        bAcabar.setEnabled(false);
        bAcabar.setAlpha(0f);
        bVolar = findViewById(R.id.bVolar);
        bVolar.setEnabled(false);
        bVolar.setAlpha(0f);
        bAcabar2 = findViewById(R.id.bAcabar2);
        bAcabar2.setEnabled(false);
        bAcabar2.setAlpha(0.5f);

        //Intent que recupera el id enviat des de la pantalla anterior
        Intent i = getIntent();
        id = i.getIntExtra("id", defaultValue);

        //Definició de tots els items dels sliders. Tots definits a la vegada
        itemExplicacions = new ArrayList<>();
        ItemExplicacion Uno = new ItemExplicacion("atomo_lapiz_color.json", "LOS ÁTOMOS", getString(R.string.atomos_1));
        ItemExplicacion Dos = new ItemExplicacion("atomo_nucleo_color.json", "LOS ÁTOMOS", getString(R.string.atomos_2));
        ItemExplicacion Tres = new ItemExplicacion("atomo_color.json", "LOS ÁTOMOS", getString(R.string.atomos_3));
        ItemExplicacion Cuatro = new ItemExplicacion("bateria_color.json", "ELECTRICIDAD", getString(R.string.electricidad_1));
        ItemExplicacion Seis = new ItemExplicacion("iman_estatico_color.json", "LOS IMANES", getString(R.string.iman_1));
        ItemExplicacion Siete = new ItemExplicacion("imanes_brillos_color.json", "LOS IMANES", getString(R.string.iman_2));
        ItemExplicacion Ocho = new ItemExplicacion("motor_ilustracion.json", "MOTOR DE CORRIENTE CONTINUA", getString(R.string.motor_1));
        ItemExplicacion Nueve = new ItemExplicacion("motor_imanes.json", "EL ESTATOR", getString(R.string.motor_2));
        ItemExplicacion Diez = new ItemExplicacion("motor_rotor.json", "EL ROTOR", getString(R.string.motor_3));
        ItemExplicacion Once = new ItemExplicacion("motor_helice.json", "HÉLICES", getString(R.string.helices_1));
        ItemExplicacion Doce = new ItemExplicacion("helices_color.json", "HÉLICES", getString(R.string.helices_2));
        ItemExplicacion Trece = new ItemExplicacion("helices_rotando_color.json", "HÉLICES", getString(R.string.helices_3));
        ItemExplicacion Diecisiete = new ItemExplicacion("ultrasonido_desdearriba.json", "ULTRASONIDO", getString(R.string.ultrasonido_1));
        ItemExplicacion Dieciocho = new ItemExplicacion("ultrasonido_color.json", "ULTRASONIDO", getString(R.string.ultrasonido_2));

        adapter = new SliderAdapterApren(itemExplicacions, this);

        viewPager = findViewById(R.id.sliderAprende);
        viewPager.setAdapter(adapter);
        viewPager.setPadding(80, 0, 80, 0);

        //Col·locació dels items que corresponen a cada lliçó, segons el que seleccione l'usuari
        switch (id) {
            case 1:
                itemExplicacions.add(Uno);
                itemExplicacions.add(Dos);
                itemExplicacions.add(Tres);
                numPuntos = 3;
                indicador.setText("Lección 1 - Los átomos");
                break;

            case 2:
                itemExplicacions.add(Cuatro);
                numPuntos = 1;
                indicador.setText("Lección 2 - Electricidad");
                bAcabar2.setEnabled(true);
                bAcabar2.setAlpha(1f);
                break;

            case 3:
                itemExplicacions.add(Seis);
                itemExplicacions.add(Siete);
                numPuntos = 2;
                indicador.setText("Lección 3 - Los imanes");
                break;

            case 4:
                itemExplicacions.add(Ocho);
                itemExplicacions.add(Nueve);
                itemExplicacions.add(Diez);
                numPuntos = 3;
                indicador.setText("Lección 4 - Motor de corriente continua");
                bAcabar2.setEnabled(false);
                bAcabar2.setAlpha(0f);
                bAcabar.setEnabled(false);
                bAcabar.setAlpha(0.5f);
                bVolar.setEnabled(false);
                bVolar.setAlpha(0.5f);
                break;

            case 5:
                itemExplicacions.add(Once);
                itemExplicacions.add(Doce);
                itemExplicacions.add(Trece);
                numPuntos = 3;
                indicador.setText("Lección 5 - Las hélices");
                bAcabar2.setEnabled(false);
                bAcabar2.setAlpha(0f);
                bAcabar.setEnabled(false);
                bAcabar.setAlpha(0.5f);
                bVolar.setEnabled(false);
                bVolar.setAlpha(0.5f);
                break;

            case 6:
                itemExplicacions.add(Diecisiete);
                itemExplicacions.add(Dieciocho);
                numPuntos = 2;
                indicador.setText("Lección 6 - Sensor de ultrasonido");
                bAcabar2.setEnabled(false);
                bAcabar2.setAlpha(0f);
                bAcabar.setEnabled(false);
                bAcabar.setAlpha(0.5f);
                bVolar.setEnabled(false);
                bVolar.setAlpha(0.5f);
                break;

            default:
                itemExplicacions.add(Uno);
                itemExplicacions.add(Tres);
                numPuntos = 2;
                break;
        }

        //Inicialitza el mètode que permet actualitzar el slider per a cada lliçó
        //Ja que és diferent en cada cas
        updateViewPager();

        //Crea els punts
        puntosSlide(0);

        //Inicialitza el mètoque que permet saber a quina pàgina ens trobem
        viewPager.addOnPageChangeListener(viewListener);
    }

    //Crea els punts que indiquen a quina pàgina està l'usuari
    public void puntosSlide(int position){
        puntos = new TextView[numPuntos];
        puntosLayout.removeAllViews();

        for(int i=0; i<puntos.length; i++){

            puntos[i] = new TextView(this);
            puntos[i].setText(Html.fromHtml("&#8226;"));
            puntos[i].setTextSize(25);
            puntos[i].setTextColor(getResources().getColor(R.color.gris));

            puntosLayout.addView(puntos[i]);
        }

        if(puntos.length > 0){
            puntos[position].setTextColor(getResources().getColor(R.color.colorPaleta3));
        }
    }

    ViewPager.OnPageChangeListener viewListener = new ViewPager.OnPageChangeListener() {
        @Override
        public void onPageScrolled(int position, float positionOffset, int positionOffsetPixels) {

        }

        //Controla a quina pàgina es troba l'usuari
        @Override
        public void onPageSelected(int position) {
            puntosSlide(position);
            currentPage = position;

            //Si l'usuari ha arribat a l'ítem final de cada slider, s'activen els botons per tal d'acabar o accedir als controls del drone
            if((id==1)&&(currentPage==2)){
                bAcabar2.setEnabled(true);
                bAcabar2.setAlpha(1f);
            }

            if((id==3)&&(currentPage==1)){
                bAcabar2.setEnabled(true);
                bAcabar2.setAlpha(1f);
            }

            if((id==4)&&(currentPage==2)){
                botones();
            }

            if((id==5)&&(currentPage==2)){
                botones();
            }

            if((id==6)&&(currentPage==1)){
                botones();
            }
        }

        @Override
        public void onPageScrollStateChanged(int state) {

        }
    };

    private void updateViewPager() {
        viewPager.getAdapter().notifyDataSetChanged();
    }

    //Mètode onclick per passar a la pantalla de Controls
    public void volarApren (View view){
        Intent intentVolarA = new Intent(LeccionAprende.this, Controles.class);
        intentVolarA.putExtra("pantalla", pantalla);
        startActivity(intentVolarA);
    }

    //Mètode onclick per tornar al menú d'Aprèn
    public void acabar (View view){
        Intent intentAcabar = new Intent(LeccionAprende.this, Apren.class);
        startActivity(intentAcabar);
    }

    //Mètode per tornar a la página anterior
    public void volver (View v){
        onBackPressed();
    }


    //Mètode per tornar al menú principal
    public void menu (View v){
        Intent menu = new Intent(LeccionAprende.this, MainActivity.class);
        startActivity(menu);
    }

    //Mètode per habilitar els botons d'acabar i volar
    public void botones(){
        bAcabar.setEnabled(true);
        bAcabar.setAlpha(1f);
        bVolar.setEnabled(true);
        bVolar.setAlpha(1f);
        bVolar.setElevation(3);
        bAcabar2.setEnabled(false);
        bAcabar2.setAlpha(0f);
    }

    //Mètode que s'executa quan acaba l'activity i es passa a una altra
    @Override
    public void finish() {
        super.finish();
        overridePendingTransition(R.anim.slide_in_left, R.anim.slide_out_right);
    }
}
