package com.example.animoi;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.core.app.ActivityOptionsCompat;
import androidx.recyclerview.widget.RecyclerView;

import java.util.ArrayList;

public class MyAdapter extends RecyclerView.Adapter<MyAdapter.MyViewHolder> {

    public ArrayList<ItemData> itemsData;
    Context mContext;

    public MyAdapter(ArrayList<ItemData> itemsData, Context mContext) {
        this.itemsData = itemsData;
        this.mContext = mContext;
    }

    @NonNull
    @Override
    public MyViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        //Crea un item amb imatge i text
        View itemLayoutView = LayoutInflater.from(parent.getContext()).inflate(R.layout.layout_item_apren, null);
        MyViewHolder viewHolder = new MyViewHolder(itemLayoutView);

        return viewHolder;
    }

    @Override
    public void onBindViewHolder(@NonNull MyViewHolder holder, final int position) {
        //Elements que apareixen en pantalla
        holder.numeroLeccion.setText(itemsData.get(position).getNumeroLeccion());
        holder.tituloLeccion2.setText(itemsData.get(position).getTituloLeccion2());
        holder.ilustracion.setImageResource(itemsData.get(position).getImageUrl());
        holder.recuadroLeccion.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                //Informació que es transmet a la pantalla IntroLeccion.java
                Intent intent = new Intent(mContext, IntroLeccion.class);
                intent.putExtra("numeroLeccion", itemsData.get(position).getNumeroLeccion());
                intent.putExtra("tituloLeccion", itemsData.get(position).getTituloLeccion());
                intent.putExtra("pregunta", itemsData.get(position).getPregunta());
                intent.putExtra("imagen_url", itemsData.get(position).getImageUrl());
                intent.putExtra("id", itemsData.get(position).getId());

                ActivityOptionsCompat options = ActivityOptionsCompat.makeSceneTransitionAnimation((Activity)mContext);
                mContext.startActivity(intent, options.toBundle());
            }
        });
    }

    @Override
    public int getItemCount() { return itemsData.size();}

    public class MyViewHolder extends RecyclerView.ViewHolder{

        //Variables
        TextView numeroLeccion, tituloLeccion2;
        ImageView ilustracion;
        LinearLayout recuadroLeccion;

        public MyViewHolder(@NonNull View itemView) {
            super(itemView);
            //Associació de variables a elements xml
            recuadroLeccion = itemView.findViewById(R.id.layoutLeccion);
            numeroLeccion = itemView.findViewById(R.id.txLeccion);
            tituloLeccion2 = itemView.findViewById(R.id.txLeccion2);
            ilustracion = itemView.findViewById(R.id.imgLeccion);
        }
    }
}