package com.example.animoi;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

public class PuntosConseguidos extends AppCompatActivity {

    private String nombre, obtener, punts;
    private TextView numPuntos, obtenerPuntos;
    private int id, puntos, defaultValue=0;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_puntos_conseguidos);

        //Associació de variables a elements xml
        numPuntos = findViewById(R.id.numPuntos);
        obtenerPuntos = findViewById(R.id.obtenetPuntos);
        obtener = obtenerPuntos.getText().toString();

        //Intent que permet recuperar el id enviat
        Intent i = getIntent();
        id = i.getIntExtra("id", defaultValue);

        //Obtenció de l'usuari guardat al SharedPreferences
        SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(PuntosConseguidos.this);
        nombre = prefs.getString("user", "DEFAULT");

        //Segons el id del projecte obtindrà uns punts o altres
        switch (id){
            case 0:
                puntos = 100;
                break;
        }

        //Assignació dels punts i del nom de l'usuari
        punts = String.valueOf(puntos);
        numPuntos.setText(punts);
        obtenerPuntos.setText(nombre + ", " + obtener);

    }


    //Mètode que permet tornar a la pantalla inicial
    public void finalizar (View view){
        Intent intentVolver= new Intent(PuntosConseguidos.this, MainActivity.class);
        startActivity(intentVolver);
    }

    //Mètode que permet accedir a la pantalla de publicació del projecte
    public void publicar (View view){
        Intent intentPublicar = new Intent(getApplicationContext(), PopUpPublicar.class);
        startActivity(intentPublicar);
        overridePendingTransition(R.anim.fade_in, R.anim.fade_out);
    }

    //Mètode per tornar al menú principal
    public void menu (View v){
        Intent menu = new Intent(PuntosConseguidos.this, MainActivity.class);
        startActivity(menu);
    }

    //Mètode per tornar a la página anterior
    public void volver (View v){
        onBackPressed();
    }
}
