package com.example.animoi;

import android.content.Context;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.preference.PreferenceManager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.viewpager.widget.PagerAdapter;

public class SliderAdapter extends PagerAdapter {

    private Context context;
    private LayoutInflater layoutInflater;

    public SliderAdapter(Context context){
        this.context = context;
    }

    //Array amb les imatges per al scroll
    public int[] slide_images = {

            R.drawable.vuela,
            R.drawable.monta,
            R.drawable.aprende
    };

    //Array per als textos del scroll
    public String[] slide_text = {
            "Vuela",
            "Monta",
            "Aprende"
    };


    @Override
    public int getCount() {
        return slide_text.length;
    }

    @Override
    public boolean isViewFromObject(@NonNull View view, @NonNull Object object) {
        return view ==(RelativeLayout) object;
    }


    //Adapter que genera el slide i assigna continguts
    @NonNull
    @Override
    public Object instantiateItem(@NonNull ViewGroup container, int position) {
        layoutInflater = (LayoutInflater) context.getSystemService(context.LAYOUT_INFLATER_SERVICE);
        View view = layoutInflater.inflate(R.layout.slide_layout, container, false);

        int width;

        //S'assignen variables de Java als elements xml
        ImageView slideIcono = view.findViewById(R.id.iconoApartados);
        TextView slideTitulo = view.findViewById(R.id.tituloApartados);

        //S'assignen a aquestes variables els valors dels arrays definits abans
        slideIcono.setImageResource(slide_images[position]);
        slideTitulo.setText(slide_text[position]);

        //Obtenció del tamany de pantalla guardat en activar la SplashScreen
        SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(context);
        width = prefs.getInt("width", 0);

        //Ajustament del tamany i la posició de la il·lustració per al slider de VOLA. Els ajustos canvien segons el tamany de pantalla
        if(position==0){
            slideIcono.setX(-10);
            slideTitulo.setX(-10);
            if(width>2000){
                slideIcono.getLayoutParams().height = 1000;
                slideIcono.setX(-50);
                slideTitulo.setX(-40);
            }
        }

        //Ajustament del tamany i la posició de la il·lustració per al slider de MONTA. Els ajustos canvien segons el tamany de pantalla
        if(position==1){
                slideIcono.getLayoutParams().height = 920;
                slideIcono.setX(400);
                slideIcono.setY(-40);
                slideTitulo.setX(-700);
                slideTitulo.setTextColor(Color.parseColor("#000000"));

            if(width>2000) {
                slideIcono.getLayoutParams().height = 1200;
                slideIcono.setX(580);
                slideIcono.setY(0);
                slideTitulo.setX(-950);
            }
        }

        //Ajustament del tamany i la posició de la il·lustració per al slider de APRÈN. Els ajustos canvien segons el tamany de pantalla
        if(position==2){
                slideIcono.getLayoutParams().height = 820;
                slideIcono.setX(120);
                slideTitulo.setX(-80);
            if(width>2000) {
                slideIcono.getLayoutParams().height = 1100;
                slideIcono.setX(200);
                slideTitulo.setX(-150);
            }
        }
        container.addView(view);
        return view;
    }

    //Evita que es continuen creant slides
    @Override
    public void destroyItem(@NonNull ViewGroup container, int position, @NonNull Object object) {
       container.removeView((RelativeLayout)object);
    }
}
