package com.example.animoi;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.DisplayMetrics;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.ImageView;

import java.util.Timer;
import java.util.TimerTask;

public class SplashScreen extends AppCompatActivity {

    private final int STR_SPLASH_TIME = 1000;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_splash_screen);
        startSplashTimer();

        //S'obtenen les dimensios de la pantalla, segons el dispositiu de l'usuari
        DisplayMetrics displayMetrics = new DisplayMetrics();
        getWindowManager().getDefaultDisplay().getMetrics(displayMetrics);
        int height = displayMetrics.heightPixels;
        int width = displayMetrics.widthPixels;

        //Guarda aquestes dimensions a l'aplicació
        SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(SplashScreen.this);
        SharedPreferences.Editor editor = prefs.edit();
        editor.putInt("width", width);
        editor.putInt("height", height);
        //editor.putInt("popUp", 0);
        editor.apply();
    }


    //Mètode que fa aparèixer aquesta pantalla durant un temps determinat
    //Passa automàticament al menú principal
    private void startSplashTimer() {
        try {
            //Contador, temps que dura la splash activity
            Timer timer = new Timer();
            timer.schedule(new TimerTask() {

                @Override
                public void run() {
                    Intent intent = new Intent(SplashScreen.this, MainActivity.class);
                    startActivity(intent);
                    overridePendingTransition(R.anim.fade_in, R.anim.fade_out);
                    finish();
                }
            }, STR_SPLASH_TIME);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
